/*
===============================================================================
 Name        : MCU_board_v1_0.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#include <cr_section_macros.h>
#include <eeprom_iap.h>
#include <stdio.h>
#include <stdbool.h>

#include "pins.h"
#include "sysinit.h"
#include "cfg.h"
#include "handlers.h"
#include "adc.h"
#include  "eeprom_iap.h"

Flags flags;
ADC_val adc_val[7];
Voltage voltage;
State state;
EEPROM eeprom;
RINGBUFF_T txring, rxring;

static volatile uint32_t ms_tick;

int main(void) {

	MySystemInit();
    // default set of attenuator after reset (read from eeprom memory)
	eeprom.iap_return_code = IAP_read_eeprom( (char*)TARGET_EEPROM_ADDRESS, mem, MEM_SIZE );
	eeprom.actual_attenuation = ((100 * mem[ATT_INTEGERS]) + (mem[ATT_TENTHS]));
    if (eeprom.iap_return_code == 0) //eeprom_read_OK
     	sky12343_driver(mem[ATT_INTEGERS],mem[ATT_TENTHS]);

	while(1) {
    	if (flags.ms)
    	{
    		flags.ms = false;
    		ADC_read_all_channels();
    		if (!DEBUG_MODE)
    		WDT_RESET();
    	}

    	if(flags.sec)
    	{
     	    flags.sec = false;
    	    Signalization_handler();
    	    PC_detection_handler();
    	    Charge_handler();
    	    Uart_handler();
    	  }
    }
    return 0 ;
}

void SysTick_Handler(void)
{
	flags.ms = true;
	ms_tick++;

	if(ms_tick == 1000)
	{
		ms_tick = 0;
		flags.sec = true;
	}
}

void UART_IRQHandler(void)
{
	Chip_UART_IRQRBHandler(LPC_USART, &rxring, &txring);
}

