/*
 * sky12343.c
 *
 *  Created on: 14. 12. 2017
 *      Author: Milan
 */

#include "sky12343.h"

static uint16_t sky12343_getdata(uint8_t att_integers,uint8_t att_tenths)
{
	uint16_t attenuation,data,reverse;

	if(att_integers <= ATTENUATION_MAX)
	{

		attenuation = ((att_integers << 2) | ((uint16_t)att_tenths / 25));
		data = ((ATT_ADDRESS << 7) | attenuation);
	}
	else
	{
		attenuation = ATTENUATION_MAX;
		data = ((ATT_ADDRESS << 7) | attenuation);
	}
	//LSB <-> MSB switch
	uint8_t s = (sizeof(data) * 8) - 1;
	for(data >>= 1; data; data >>= 1)
	{
		reverse <<=1;
		reverse |= data & 1;
		s --;
	}
	reverse <<=s;
	return reverse;

}


extern void sky12343_driver(uint8_t att_integers,uint8_t att_tenths)
{
	uint16_t data = sky12343_getdata(att_integers,att_tenths);
	Chip_SSP_SendFrame(LPC_SSP, data);
	delay_us(7);
	ATT_LATCH(true);
	delay_us(2);
	ATT_LATCH(false);
	flags.attenuation_set = true;
}


